#include "dense_matrix.h"
#include "ginac_util.h"
#include "array.h"
#include "show.h"
#include <iostream>
#include <vector>
#include <valarray>
using namespace std;
using namespace GiNaC;

template <typename Array> void check (size_t n)
{
	typedef typename Array::value_type T;
	Array x (n, 1.0);
	show ("x", x, cerr);
	Array b (n, 1.0);
	show ("b", b, cerr);
	dense_matrix<T> A (n,n);
	for (size_t i = 0; i < n; i++) 
	    for (size_t j = 0; j < n; j++)
	      A.entry(i,j) = 1;
	Array r1 = b;
	show ("r1", r1, cerr);
	Array r2 = A*x;
	show ("r2", r2, cerr);
	Array r3 = r1 - r2;
	show ("r3", r3, cerr);
}
int main () {
	const size_t n = 10;
	cerr << "             vector<double>\n";
	check <array <double, vector<double> > >(n);

	cerr << "             valarray<double>\n";
	check <array <double, valarray<double> > >(n);

	cerr << "             vector<ex>\n";
	check <array <ex,     vector<ex> > >(n);

	cerr << "             valarray<ex>\n";
	check <array <ex,     valarray<ex> > >(n);
	return 0;
}
