#ifndef _COURS_COMPILER_H
#define _COURS_COMPILER_H
//
// compiler dependent
//
// author: Pierre.Saramito@imag.fr
//
// date: 27 january 2000
//

// -----------------------------------------------------------------------
// compile with -DHAVE_MALLOC_DBG and link with -ldmalloc
// -----------------------------------------------------------------------
#ifdef HAVE_MALLOC_DBG

// macros wrapper for new and delette
// macros wrapper for new and delette
// when debuging with malloc_dbg
# include <cstdlib>
# include <dmalloc.h>
//extern void *operator new(size_t);
//extern void *operator new[](size_t);
# define        new_macro(obj)            new obj
# define        new_copy_macro(obj,val)   new obj(val)
# define        new_tab_macro(typ, n)     (new typ [(n)])
# define        delete_macro(ptr)         { if (ptr) delete (ptr); }
# define        delete_tab_macro(ptr)     { if (ptr) delete [] (ptr); }

# else // ! HAVE_MALLOC_DBG : standard c++ new, delete

#ifndef new_tab_macro
# define        new_macro(obj)             (new obj)
# define        new_copy_macro(obj,val)    (new obj(val))
# define        new_tab_macro(typ, n)      (new typ [(n)])
# define        delete_macro(ptr)          { if (ptr) delete (ptr); }
# define        delete_tab_macro(ptr)      { if (ptr) delete [] (ptr); }
#endif // new_tab_macro

# endif // HAVE_MALLOC_DBG


// -----------------------------------------------------------------------
// some goodies
// -----------------------------------------------------------------------
#include "sqr.h"
#include <iostream>

// -----------------------------------------------------------------------
// trace macros
// -----------------------------------------------------------------------
# define fatal_macro(message) \
	{ std::cerr << "fatal(" << __FILE__ << "," << __LINE__ << "): " << message << std::endl; exit(1); }
# define error_macro(message) \
	fatal_macro(message)
# define warning_macro(message) \
	{ std::cerr << "warning(" << __FILE__ << "," << __LINE__ << "): " << message << std::endl; }
#  define check_macro(ok_condition, message) \
        { if (!(ok_condition)) fatal_macro(message); }

# ifdef PARANO
#  ifdef  NDEBUG
#    undef  NDEBUG
#  endif
#  define trace_macro(message) \
        { std::cerr << "trace(" << __FILE__ << "," << __LINE__ << "): " << message << std::endl; }
#  define assert_macro(ok_condition, message) \
	check_macro(ok_condition,message)
#  define basic_assert_macro(ok_condition) \
	check_macro(ok_condition, "assertion failed: " << __STRING(ok_condition))
# else // not PARANO
#  ifndef NDEBUG
#    define NDEBUG
#  endif
#  define trace_macro(message)
#  define assert_macro(ok_condition, message)
#  define basic_assert_macro(ok_condition)
# endif // PARANO

#endif // _COURS_COMPILER_H

