#include <iostream>
#include <cmath>
#include <cstdlib>
using namespace std;

// ================================================================
// question 7
// ================================================================

template <typename T>
class daf {
  public:
    daf (double x0 = 0) : _v(x0), _d(0) {}
    // daf () : _v(0), _d(0) {}
    // daf (const daf<T>& x) : _v(x._v), _d(x._d) {}
    template <typename U> daf (const U& x) : _v(x), _d(0) {}
    daf<T>& operator= (const daf<T>& x) { _v = x._v; _d = x._d; return *this; }
    T& value()       { return _v; }
    T value()  const { return _v; }
    T diff()   const { return _d; }
    void is_variable() { _d=T(1.0); }

    friend daf<T> operator- (daf<T> f) {
	 daf<T> g;
	 g._v = -f._v;
	 g._d = -f._d;
	 return g;
    }
    friend daf<T> operator+ (daf<T> f, daf<T> g) {
	 daf<T> h;
	 h._v = f._v + g._v;
	 h._d = f._d + g._d;
	 return h;
    }
    friend daf<T> operator+ (daf<T> f, double g) {
	 daf<T> h;
	 h._v = f._v + g;
	 h._d = f._d;
	 return h;
    }
    friend daf<T> operator* (daf<T> f, daf<T> g) {
	 daf<T> h;
	 h._v = f._v * g._v;
	 h._d = f._d * g._v + f._v * g._d;
	 return h;
    }
    friend daf<T> operator* (double f, daf<T> g) {
	 daf<T> h;
	 h._v = f * g._v;
	 h._d = f * g._d;
	 return h;
    }
    friend daf<T> sin (daf<T> f) {
	 daf<T> g;
	 g._v = sin(f._v);
	 g._d = f._d*cos(f._v);
	 return g;
    }
    friend daf<T> cos (daf<T> f) {
	 daf<T> g;
	 g._v = cos(f._v);
	 g._d = -f._d*sin(f._v);
	 return g;
    }
    friend daf<T> exp (daf<T> f) {
	 daf<T> g;
	 g._v = exp(f._v);
	 g._d = f._d*exp(f._v);
	 return g;
    }
  // data:
    T _v, _d;
};
template <typename T>
T J(const T& x) {
	        T t = 2.0*x*(x+1.0);
	        return (t + sin(x))*t;
}
template <typename T> T dJ_dx  (T x) { daf<T> y (x); y.is_variable(); return J(y).diff(); }
template <typename T> T d2J_dx2(T x) { daf<T> y (x); y.is_variable(); return dJ_dx(y).diff(); }
template <typename T> T d3J_dx3(T x) { daf<T> y (x); y.is_variable(); return d2J_dx2(y).diff(); }


double question6 (double u0_base) {

    daf<double> u(u0_base);
    u.is_variable();
    cout << "J0 = " << J(u).value() << endl;
    cout << "dJ0 = " << dJ_dx(u).value() << endl;
    cout << "d2J0 = " << d2J_dx2(u).value() << endl;
    cout << "d3J0 = " << d3J_dx3(u).value() << endl;
    return 0;
}
double question8 (double u0_base) {
    cout << "question 8" << endl;
    double epsilon = 1e-7;
    double u = u0_base;
    double du = 0;
    size_t i = 0;
    cout << "i u J J' J'' du " << endl;
    do {
        double g0 = J(u);
        double g1 = dJ_dx(u);
        double g2 = d2J_dx2(u);
        cout << i << " " 
	     << u << " " 
	     << g0 << " "
	     << g1 << " "
	     << g2 << " "
	     << du << " "
	     << endl;
	du = - g1/g2;
	u += du;
	++i;
    } while (fabs(du) >= epsilon);
    return u;
}
// ================================================================
int main(int argc, char**argv) {
    double u0 = (argc > 1) ? atof(argv[1]) :  1;
    question6(u0);
    question8(u0);
    return 0;
}
