set terminal latex
set output "extreme.tex"

set size square
set logscale
set xtics (                             \
        "[r]{$1$}"   	   1,        \
        "[r]{$10^{1}$}"   1e+1,        \
        "[r]{$10^{2}$}"   1e+2,        \
        "[r]{$10^{3}$}"   1e+3,        \
        "[r]{$10^{4}$}"   1e+4        \
        )
set ytics (                             \
        "[r]{$10^{-7}$}"   1e-7,        \
        "[r]{$10^{-5}$}"   1e-5,        \
        "[r]{$10^{-3}$}"   1e-3,        \
        "[r]{$10^{-1}$}"   1e-1,        \
        "[r]{$10^{1}$}"    1e+1        \
        )
set xlabel "{\\large $N$}"
set  label "[r]{\\large $\\xi_2-\\xi_1$}" at graph 0.70, 0.25
set  label "[l]{\\large $\\xi_{N/2+1}-\\xi_{N/2}$}" at graph 0.45, 0.78

plot [1:1e+4][1e-7:10]  \
	'centre.dat'  notitle w lp lt 1 pt 8, \
	'extreme.dat' notitle w lp lt 1 pt 8

