set terminal pslatex
set output "fd-pcg-2d.tex"

set logscale y
set xtics nomirror (0, 100, 200, 300, 400, 500, 600)
set ytics (                          \
        "[r]{$10^{-15}$}"   1e-15,   \
        "[r]{$10^{-10}$}"   1e-10,   \
        "[r]{$10^{-5}$}"    1e-5,    \
        "[r]{$1$}"          1        \
        )

set xlabel "{\\large $i$}"
set  label "[r]{\\large $r(n,i)$}" at graph -0.1, 0.5

set arrow from 0, 1e-15 to 650, 1e-15 nohead lt 3

plot [0:650][1e-18:100] \
	'fd-pcg-2d-n=200.dat' u 2:3 title "[r]{pr\\'econditionn\\'e}" w l lt 1, \
	'fd-cg-2d-n=200.dat'  u 2:3 title "[r]{non pr\\'econditionn\\'e}" w l lt 4 

# pause -1 "<retour>"

