set terminal latex
set output "fd-pcg-niter-2d.tex"

set logscale
set size square
set xtics (                          \
        "[r]{$10^{3}$}"   1e3,   \
        "[r]{$10^{2}$}"   1e2,   \
        "[r]{$10$}"      1e1,   \
        "[r]{$1$}"          1        \
        )
set ytics (                          \
        "[r]{$10^{3}$}"   1e3,   \
        "[r]{$10^{2}$}"   1e2,   \
        "[r]{$10$}"      1e1,   \
        "[r]{$1$}"          1        \
        )
set label "[r]{$2/3$}" at graph 0.45, 0.85
set arrow from graph 0.50, 0.90 to graph 0.65, 0.90 nohead
set arrow from graph 0.65, 0.90 to graph 0.50, 0.80 nohead
set arrow from graph 0.50, 0.80 to graph 0.50, 0.90 nohead

set xlabel "{\\large $n$}"
set  label "[r]{\\large ${\\mathcal N}(n,\\varepsilon)$}" at graph -0.1, 0.5
# --------
# a = 2./3
# --------
a               = 0.659128   #     +/- 0.004192     (0.6361%)
c               = 6.29465    #     +/- 0.1299       (2.063%)
f(x) = c*x**a
# fit f(x) 'niter.dat' via a, c

plot [1:1000][1:1000] 'fd-pcg-niter-2d.dat' notitle w lp

# pause -1 "<retour>"
