#include "ldlt_1d.h"
#include <iostream>
using namespace std;
double u (double x) { return (1-x*x)/2; }
int main (int argc, char** argv) {
        size_t n = (argc > 1) ? atoi(argv[1]) : 11;
	valarray<double> a (2.0, n-1);
	valarray<double> al (-1.0, n-2);
	ldlt_1d (a, al);
	double h = 2.0/n;
	valarray<double> b (h*h, n-1);
	ldlt_solve_1d (a, al, b);
        valarray<double> pi_h_u (n-1);
        for (size_t i = 0; i < n-1; i++)
             pi_h_u [i] = u (-1+(i+1)*h);
        valarray<double> uerr = abs(pi_h_u - b);
        double err = uerr.max();
        cerr << "err " << err << endl;
        return err > 1e-8 ? 1 : 0;
}
