#include "finite_differences.h"
#include "valarray_util.h"
#include "cg.h"
#include "eye.h"
#include <iostream>
using namespace std;

double u (double x) { return x*(1-x)/2; }
int main (int argc, char** argv) {
        size_t n = (argc > 1) ? atoi(argv[1]) : 10;
	double h = 1.0/(n+1);
	finite_differences A;
	valarray<double> b (h*h, n);
	valarray<double> uh (0., n);
	cg (A, uh, b, eye(), 2*n, 1e-17);
        valarray<double> pi_h_u (n);
        for (size_t i = 0; i < n; i++)
             pi_h_u [i] = u ((i+1)*h);
        valarray<double> uerr = abs(pi_h_u-uh);
        double err = uerr.max();
        cerr << "err " << err << endl;
        return err > 1e-7 ? 1 : 0;
}
