set terminal latex
set output "finite_element_cvg.tex"

set logscale
set size square
set ytics (                \
        "[r]{$10^{-6}$}"   1e-6,        \
        "[r]{$10^{-5}$}"   1e-5,        \
        "[r]{$10^{-4}$}"   1e-4,        \
        "[r]{$10^{-3}$}"   1e-3        \
        )
set xtics (                \
        "{$10^{-3}$}"   1e-3,        \
        "{$10^{-2}$}"   1e-2,        \
        "{$10^{-1}$}"   1e-1,        \
        "{$10^{0}$}"   1e-0        \
        )
set xlabel "{\\Large $h$}"
set  label "[l]{\\large $\\|u_h-\\pi_hu\\|_{\\infty,\\Omega}$}" at graph 0.1, 0.85

plot [1e-3:1][1e-6:1e-3] "finite_element_cvg.dat" u 1:2 notitle w lp

