#include <fstream>
#include <string>
template <typename T>
void plot (const mesh<T>& Th, const std::valarray<T>& uh, std::string name = "output") {
        std::ofstream gdat ((name+".gdat").c_str());
        std::cerr << "! file \"" << name << ".gdat\" created.\n";
	for (size_t l = 0; l < Th.size(); l++) {
	      size_t i = Th [l][0];
	      size_t j = Th [l][1];
	      size_t k = Th [l][2];
	      const point<T>& xi = Th.vertice (i);
	      const point<T>& xj = Th.vertice (j);
	      const point<T>& xk = Th.vertice (k);
	      gdat << xi [0] << " " << xi [1] << " " << uh [i] << "\n"
	           << xj [0] << " " << xj [1] << " " << uh [j] << "\n\n"
	           << xk [0] << " " << xk [1] << " " << uh [k] << "\n"
	           << xk [0] << " " << xk [1] << " " << uh [k] << "\n\n\n";
	}
	gdat.close ();
        std::ofstream plot ((name+".plot").c_str());
        std::cerr << "! file \"" << name << ".plot\" created.\n";
	plot << "splot '" << name << ".gdat' notitle with lines\n"
	     << "pause 10000 '<ctrl-C>'\n";
        plot.close();
	std::cerr << "! gnuplot " + name + ".plot\n";
	system (("gnuplot " + name + ".plot").c_str());
	std::cerr << "! rm -f " + name + ".plot " + name + ".gdat\n";
	system (("rm -f " + name + ".plot " + name + ".gdat").c_str());
}
