#ifndef _COURS_LAGRANGE_DERIVATIVE_H
#define _COURS_LAGRANGE_DERIVATIVE_H
#include "legendre.h"
//
// input:
//	x(0:N)  : the Legendre-Gauss-Lobatto nodes x[i]
//      LN(0:N) : the value L(N,x[i]) of the N-th Legendre polynom at x[i]
// 
// output: 
//	d(0:N,0:N): the derivatives d(i,j) = l_j'(x[i]) of the Lagrange polynom at x[i]
//	    where the Lagrange polynom satisfies l_j(x[i]) = delta(i,j) (Kronecker)
//	    and degree(L_j) <= N
//
// reference : C. Canuto, M. Y. Hussaini, A. Quarteroni and T. A. Zang
// Spectral methods in Fluid Dynamics
// Springer Verlag, 1988
// page 65
//
#include "lagrange_derivative.icc"
#endif // _COURS_LAGRANGE_DERIVATIVE_H
