#include "lagrange_derivative_check.h"
#include "lagrange_derivative.h"
#include "legendre_gauss_lobatto.h"
#include "dense_matrix.h"
#include "interpolate_1d.h"
#include <vector>
#include <iostream>
using namespace std;
int main (int argc, char **argv) {

        unsigned int N = argc > 1 ? atoi(argv[1]) : 5;
	vector<double> x (N+1);
	vector<double> w (N+1);
        legendre_gauss_lobatto (x, w);
        vector<double> LN = interpolate (x, legendre<double>(N));
        dense_matrix<double> d (N+1,N+1);
	lagrange_derivative (x, LN, d);

	double err = lagrange_derivative_check (x.begin(), w.begin(), d, N);
	cerr << "err = " << err << endl;
	return err < 1e-7 ? 0 : 1;
}
