function r = legendre_gauss(N);

%  computes the roots of the Legendre polynomial of degree N.

n = [1:N-1];                   %  Indices
d = n./sqrt(4*n.^2-1);         %  Create subdiagonals
J = diag(d,1)+diag(d,-1);      %  Create Jacobi matrix
r = sort(eig(sparse(J)));      %  Compute eigenvalues
end

