set terminal latex
set output "loi-poid.tex"

set size square
set logscale
set xtics (                             \
        "[r]{$1$}"         1,        	\
        "[r]{$10^{1}$}"   1e+1,        	\
        "[r]{$10^{2}$}"   1e+2,        	\
        "[r]{$10^{3}$}"   1e+3,        	\
        "[r]{$10^{4}$}"   1e+4        	\
        )
set ytics (                             \
        "[r]{$10^{-8}$}"   1e-8,        \
        "[r]{$10^{-6}$}"   1e-6,        \
        "[r]{$10^{-4}$}"   1e-4,        \
        "[r]{$10^{-2}$}"   1e-2,        \
        "[r]{$10^{1}$}"    1    	\
        )
set xlabel "{\\large $N$}"
set  label "[l]{\\small $\\max_i \\left|\\omega_i - \\pi N^{-1}(1-\\xi_i^2)^{1/2}\\right|$}" at graph 0.20, 0.90

plot [1:1e+4][1e-8:1]  'loi-poid.dat' notitle w lp lt 1 pt 8
