#!/bin/sh
if test $#  -eq 0; then
        echo "usage: $0 <N>[.psplot]"
        echo "     output: L-<N>.psplot"
        exit 1
fi
N=$1
cat > L-${N}.psplot << EOF
set terminal latex
set output "L-${N}.tex"

L(n,x) = (n==0)?1:(n==1)?x:((2*n-1)*x*L(n-1,x)-(n-1)*L(n-2,x))/n
set size ratio 0.25 1, 1
set arrow from -1,0 to 1,0 lt 1
set noborder
set noxtics
set noytics
eps = 0.01
set arrow from 0,-1 to 0,-1+eps nohead lt 3
set arrow from 0, 1 to 0, 1-eps nohead lt 3
set label "[l]{\\\\large \$L_${N}\$}" at graph -0.1, 0.8
plot [-1:1][-1:1] L(${N},x) notitle w l lt 5

#pause -1 "<retour>"
EOF

echo "! file \"L-${N}.psplot\" created" >&2

