#include <iostream>
#include <cmath>
template <typename T, typename F1, typename F2>
int newton (const F1& f, const F2& df_dx, T& x, size_t n_max, const T& epsilon) {
  for (size_t n = 0; n < n_max; n++) {
    T dx = - f(x)/df_dx(x);
    std::clog << "newton: "<< n << " " << dx << std::endl;
    if (std::fabs(dx) < epsilon) return 0;
    x += dx;
  }
  return 1;
}
