#include "odag.h"
#include <iostream>
using namespace std;
template <typename T>
T func(const T& x, const T& y) {
	T z = sqrt(x);
        return y*z+sin(z);
}
int main () {
  dag<double> x = 2;                // Initialize variable x
  dag<double> y = 3;                // Initialize variable y
  dag<double> f = func(x,y);        // Evaluate function and record DAG
  f.diff(0,1);        		    // Differentiate f (index 0 of 1)
  double fval = f.x();              // Value of function
  cout << "f(x,y)=" << fval << endl;
  double dfdx = x.d(0);             // Value of df/dx (index 0 of 1)
  cout << "df/dx(x,y)=" << dfdx << endl;
  double dfdy = y.d(0);             // Value of df/dy (index 0 of 1)
  cout << "df/dy(x,y)=" << dfdy << endl;
}
