// dans ]-1,1[ avec n*n elements
#include "finite_differences_2d.h"
#include "fd_ssor_2d.h"
#include "valarray_util.h"
#include "cg.h"
#include "sqr.h"
#include <iostream>
using namespace std;
double u (const double& x, const double& y) { return (1-sqr(x))*(1-sqr(y))/2; }
double f (const double& x, const double& y) { return 2-sqr(x)-sqr(y); }

int main (int argc, char** argv) {
        size_t n = (argc > 1) ? atoi(argv[1]) : 10;
	double h = 2.0/n;
        valarray<double> pi_h_u = interpolate (n, u);
	valarray<double> pi_h_f = interpolate (n, f);
	valarray<double> b ((n-1)*(n-1));
        for (size_t i = 0; i < n-1; i++)
            for (size_t j = 0; j < n-1; j++)
	      b [i+(n-1)*j] = h*h*pi_h_f [(i+1)+(n+1)*(j+1)];
	valarray<double> x (0.0, (n-1)*(n-1));
        finite_differences_2d A (n-1);
        fd_ssor_2d m (n-1);
        cg (A, x, b, m, 2*sqr(n-1), 1e-17);
	valarray<double> uh (0.0, (n+1)*(n+1));
        for (size_t i = 0; i < n-1; i++)
            for (size_t j = 0; j < n-1; j++)
	      uh [(i+1)+(n+1)*(j+1)] = x [i+(n-1)*j];
        double err = abs(pi_h_u-uh).max();
        cerr << "err " << err << endl;
        return err > 1e-7 ? 1 : 0;
}
