%
% load matrix market
%
% author : Pierre.Saramito@imag.fr
%
% date: 9 june 2001
%
%
function m = read_mm (file_name)

    file = fopen (file_name, 'r');
    printf ('! load \"%s\"\n', file_name);
    % skip '%%MatrixMarket matrix coordinate real general'
    fgetl (file);
    [nrow, ncol, nnz] = fscanf (file, '%d%d%d', "C");
    m = zeros(nrow,ncol);
    [buffer, nbuffer] = fscanf (file, '%d%d%g', 3*nnz);
    if 3*nnz != nbuffer 
	fprintf (stderr, "read_mm: error while reading \"%s\"\n", file_name);
	fprintf (stderr, "read_mm: expect nnz=%d, get nnz=%d\n", nnz,nnz1);
	exit (1);
    end
    for p = 1:nnz
      i = buffer(3*(p-1)+1);
      j = buffer(3*(p-1)+2);
      v = buffer(3*p);
      m(i,j) = v;
    end
    fclose(file);
