set terminal pslatex auxfile
set output "singularite-1d.tex"

u(alpha,x) = (1-x*x)**alpha

set xtics nomirror (-1, 0, 1)
set ytics nomirror (0, 1)

set label "[l]{$\\alpha=1/2$}" at -0.80, 0.85
set label "[l]{$\\alpha=3/2$}"   at -0.60, 0.75
set label "[l]{$\\alpha=3$}" at -0.50, 0.45

set xlabel "{\\Large $x$}"
set  label "[r]{$u_\\alpha(x)$}" at graph -0.05, 0.5

plot [-1:1][-0.2:1.2] \
	u(0.5,x) notitle w l lt 1, \
	u(1.5,x) notitle w l lt 2, \
	u(3.0,x) notitle w l lt 1

