set terminal latex
set output "spectral-pcg-cvg.tex"

a_theorie = ((pi**2-4)/(pi**2+4))**2
print "a_theorie = ", a_theorie
# log_a_theorie   = log(a_theorie)
# log10_a_theorie = log_a_theorie/log(10.)
# log_c = 1
# log_a = log_a_theorie
# f(x) = log_a*x + log_c
# fit [3:16] f(x) 'spectral-pcg-cvg-32.dat' u 2:(log($3)) via log_c,log_a 
# a = exp(log_a)
# c = exp(log_c)
# 
# print "a_theorie = ", a_theorie, ", a = ", a
# 
# =>	a_theorie = 0.179097496621192, a = 0.181736473632944

set logscale y
set ytics nomirror (                             \
        "[r]{$10^{-16}$}"   1e-16,        \
        "[r]{$10^{-12}$}"   1e-12,        \
        "[r]{$10^{-8}$}"   1e-8,        \
        "[r]{$10^{-4}$}"   1e-4,       \
        "[r]{$1$}"   1       \
        )
set xtics nomirror (0, 5, 10, 15, 20)

# draw the triangle
c0 = 1e-5
i1 = 10
i2 = i1+4
r1 = c0*a_theorie**i1
r2 = c0*a_theorie**i2
set label "[r]{$\\left(\\frac{\\pi^2-4}{\\pi^2+4}\\right)^2\\approx0.18$}" at i1-1, sqrt(r1*r2)
set arrow from i1, r1 to i2, r2 nohead lt 1
set arrow from i2, r2 to i1, r2 nohead lt 1
set arrow from i1, r2 to i1, r1 nohead lt 1

set xlabel "{\\large $i$}"
set  label "[r]{\\large $\\|r^{(i)}\\|$}" at graph -0.12, 0.60

plot [0:20][1e-17:10] \
 	'spectral-pcg-cvg-32.dat'  u 2:3 title "[r]{$N=32$\\,\\ }"  w lp lt 4 pt  6,  \
 	'spectral-pcg-cvg-64.dat'  u 2:3 title "[r]{$N=64$\\,\\ }"  w lp lt 1 pt 10, \
 	'spectral-pcg-cvg-128.dat' u 2:3 title "[r]{$N=128$}" w lp lt 3 pt 7

# pause -1 "<retour>"
 
