#include "legendre_gauss_lobatto.h"
#include "lagrange_derivative.h"
#include "spectral_energy.h"
#include "matrix.h"
#include "range.h"
#include "cg.h"
#include <limits>
template <typename Size, typename Array>
void spectral_dirichlet (const Array& zeta, const Array& w, const Array& b, Size N,
		Array& uh) {
	typedef typename Array::value_type T;	
	spectral_energy<T> a (zeta, w);
        Array x (N-1);
	T tol = 10*std::numeric_limits<T>::epsilon();
	if (cg (a, x, b, 2*N, tol) != 0) {
	    std::cerr << "cg: precision not reached\n";
	    exit (1);
	}
        uh [0] = uh [N] = 0;
	uh [range (1,N-1)] = x;
}
