#include "legendre_gauss_lobatto.h"
#include "spectral_energy.h"
#include "interpolate_1d.h"
#include "range.h"
#include "valarray_util.h"
#include "cg.h"
#include "eye.h"
#include "u_exact.h"
#include <limits>
using namespace std;
int main (int argc, char**argv) {
	size_t N     = (argc > 1) ? atoi(argv[1]) : 10;
	double gamma = (argc > 2) ? atof(argv[2]) :  5;
        valarray<double> zeta (N+1);
        valarray<double> w (N+1);
        legendre_gauss_lobatto (zeta, w);
        valarray<double> mf = w*interpolate (zeta, f(gamma));
        valarray<double> b  = mf [range(1,N-1)];
        spectral_energy<double> a (zeta, w);
        valarray<double> x (N-1);
        cg (a, x, b, eye(), 2*N, 1e-15);
        valarray<double> uh (N+1);
        uh [range (1,N-1)] = x;
        uh [0] = uh [N] = 0;
	valarray<double> pi_N_u = interpolate (zeta, u(gamma));
	cerr << "err   " << abs (pi_N_u - uh).max() << endl;
}
