#include <iterator>
#include <iostream>
#include <cstdlib>
#include <cmath>
#include "pythag.h"

#define SIGN(a,b) ((b) >= 0.0 ? std::fabs(a) : -std::fabs(a))

template <typename Iterator1, typename Iterator2, typename Size>
void tqli (Iterator1 d, Iterator2 e, Size n)
{
	typedef typename std::iterator_traits<Iterator1>::value_type T;
	Size m,l,iter,i;
	T s,r,p,g,f,dd,c,b;
	for (i=2;i<=n;i++) e[i-1]=e[i];
	e[n]=0.0;
	for (l=1;l<=n;l++) {
	    iter=0;
	    do {
	      for (m=l;m<=n-1;m++) {
		dd=std::fabs(d[m])+std::fabs(d[m+1]);
		if ((T)(std::fabs(e[m])+dd) == dd) break;
	      }
	      if (m != l) {
		iter++;
		if (iter == 30) { std::cerr << "Too many iterations in tqli\n"; exit(1); }
		g=(d[l+1]-d[l])/(2.0*e[l]);
		r=pythag(g,1.0);
		g=d[m]-d[l]+e[l]/(g+SIGN(r,g));
		s=c=1.0;
		p=0.0;
		for (i=m-1;i>=l;i--) {
			f=s*e[i];
			b=c*e[i];
			e[i+1]=(r=pythag(f,g));
			if (r == 0.0) {
				d[i+1] -= p;
				e[m]=0.0;
				break;
			}
			s=f/r;
			c=g/r;
			g=d[i+1]-p;
			r=(d[i]-g)*s+2.0*c*b;
			d[i+1]=g+(p=s*r);
			g=c*r-b;
		}
		if (r == 0.0 && i >= l) continue;
		d[l] -= p;
		e[l]=g;
		e[m]=0.0;
	      }
	    } while (m != l);
	}
}
