%
% write matrix market
%
%
% author : Pierre.Saramito@imag.fr
%
% date: 9 june 2001
%
function write_mm (m, file_name)

    % ----------------------------------------
    % get sparse structure
    % ----------------------------------------
    % filter values lower to a yield
    % [ia, ja, a] = dns_to_coo(m);

    [ia, ja, a] = find(m);

    [nrow,ncol] = size(m);
    [nnz, dummy] = size(ia);
    % ----------------------------------------
    % output
    % ----------------------------------------
    fichier = fopen (file_name, 'w');
    fprintf (stderr, '! file \"%s\" created\n', file_name);
    fprintf (fichier, '%%%%MatrixMarket matrix coordinate real general\n');
    fprintf (fichier, '%d %d %d\n', nrow, ncol, nnz);
    for p = 1:nnz
	fprintf (fichier, '%d %d %.15g\n', ia(p), ja(p), a(p));
    end
    fclose(fichier);

